<?php
/**
 * @copyright PayAnyWay, 2017
 * SimpleCaddy PayAnyWay processor
 * @version 1.00 for Joomla 3.x
 * @license GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access allowed to this file
defined( '_JEXEC' ) or die( 'Restricted access' );
if (file_exists(JPATH_ROOT.'/components/com_simplecaddy/simplecaddy.class.php')) {
	require_once(JPATH_ROOT . '/components/com_simplecaddy/simplecaddy.class.php');
}
else {
	return;
}

/**
 * This plugin has three parts:
 * top part is getting the SimpleCaddy functions library
 * in the function onContentPrepare are the Joomla functions to manage the plugin in the content
 * the function showPayAnyWayScreen displays and manages PayAnyWay specifics
 */

class scpayanywayconfiguration extends JTable { // this is the standard configuration class for the plugin
// naming is {pluginname}configuration
	var $id;
	var $mnt_id;
	var $mnt_data_integrity_code;
	var $mnt_server;
	var $mnt_test_mode;
	var $mnt_kassa;

	function __construct(){
		$lang = JFactory::getLanguage();
		$lang->load('plg_content_scpayanyway', JPATH_ADMINISTRATOR);
		$db	= JFactory::getDBO();
		try {
		   	parent::__construct( '#__sc_payanyway', 'id', $db );
		}
		catch (Exception $e) {
			$query= "CREATE TABLE `#__sc_payanyway` (
			`id`  						INT 			NULL AUTO_INCREMENT,
			`mnt_id`  					INT(11) 		NULL,
			`mnt_data_integrity_code`  	VARCHAR(255) 	NULL,
			`mnt_server`  				VARCHAR(255) 	NULL,
			`mnt_test_mode`  			VARCHAR(1) 		NULL,
			`mnt_kassa`  				VARCHAR(1) 		NULL,
			PRIMARY KEY (`id`)
			);";
			$this->_db->setQuery($query);
			$this->_db->execute();
			// now reconstruct, since it failed above...
			parent::__construct( '#__sc_payanyway', 'id', $db );
		}
		// get the first and only useful record in the db here
		$query=$this->_db->getQuery(true);
		$query->select("id");
		$query->from("`$this->_tbl`");
		$this->_db->setQuery($query);
		$id=$this->_db->loadResult(); // this sets the first ID as the one to use.
		$this->load($id); // load the first id
	}

	function _showconfig() { // mandatory function name
		$lang = JFactory::getLanguage(); // joomla's backend does not load frontend languages by itself
		$extension = 'plg_content_scpayanyway'; // so we need to do this manually here
		$lang->load($extension);
		require_once(JPATH_COMPONENT_SITE."/simplecaddy.class.php");
		$this->load();
		display::header(); // while this would be better inside the display function, a plugin does not have access to this
		JToolBarHelper::title( JText::_( "SCPAW_CONFIGURATION" ), 'generic.png');
		JToolbarHelper::custom("save", "save", "", JText::_("SCPAW_SAVE"), false);
		JToolbarHelper::cancel();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
		?>
		<form name="adminForm" id="adminForm">
			<table class="adminform">
				<tr>
					<td style="width: 250px;">
						<label for="mnt_id">
							<?php echo JText::_("SCPAW_MNT_ID");?>
						</label>
					</td>
					<td>
						<input type="text" id="mnt_id" name="mnt_id" value="<?php echo $this->mnt_id; ?>" size="100" />
					</td>
				</tr>
				<tr>
					<td style="width: 250px;">
						<label for="mnt_data_integrity_code">
							<?php echo JText::_("SCPAW_MNT_DATA_INTEGRITY_CODE");?>
						</label>
					</td>
					<td>
						<input type="text" id="mnt_data_integrity_code" name="mnt_data_integrity_code" value="<?php echo $this->mnt_data_integrity_code; ?>" size="100" />
					</td>
				</tr>
				<tr>
					<td style="width: 250px;">
						<label for="mnt_server">
						<?php echo JText::_("SCPAW_MNT_SERVER");?>
						</label>
					</td>
					<td>
						<?php
						$show_hide = array (
							JHTML::_('select.option', 'www.payanyway.ru', JText::_('SCPAW_MNT_SERVER_PROD')),
							JHTML::_('select.option', 'demo.moneta.ru',   JText::_('SCPAW_MNT_SERVER_DEMO')),
						);
						echo JHTML::_('select.genericlist', $show_hide, 'mnt_server',  'class="inputbox"', 'value', 'text', $this->mnt_server);
						?>
					</td>
				</tr>
				<tr>
					<td style="width: 250px;">
						<label for="mnt_test_mode">
							<?php echo JText::_("SCPAW_MNT_TEST_MODE");?>
						</label>
					</td>
					<td>
						<?php
						$show_hide = array (
							JHTML::_('select.option', '0', JText::_('SCPAW_NO')),
							JHTML::_('select.option', '1', JText::_('SCPAW_YES')),
						);
						echo JHTML::_('select.genericlist', $show_hide, 'mnt_test_mode',  'class="inputbox"', 'value', 'text', $this->mnt_test_mode);
						?>
					</td>
				</tr>
				<tr>
					<td style="width: 250px;">
						<label for="mnt_kassa">
							<?php echo JText::_("SCPAW_MNT_KASSA");?>
						</label>
					</td>
					<td>
						<?php
						$show_hide = array (
							JHTML::_('select.option', '0', JText::_('SCPAW_NO')),
							JHTML::_('select.option', '1', JText::_('SCPAW_YES')),
						);
						echo JHTML::_('select.genericlist', $show_hide, 'mnt_kassa',  'class="inputbox"', 'value', 'text', $this->mnt_kassa);
						?>
					</td>
				</tr>
			</table>
			<input type="hidden" name="option" value="com_simplecaddy" />
			<input type="hidden" name="action" value="pluginconfig"/>
			<input type="hidden" name="pluginname" value="scpayanyway"/>
			<input type="hidden" name="task" />
			<input type="hidden" name="id" value="<?php echo $this->id;?>"/>
		</form>
	<?php
	}

	function save($src="", $orderingFilter = '', $ignore = '') { // mandatory function to save any variables
		$this->bind($_REQUEST); // get all the fields from the admin form
		$b=$this->store(); // store the relevant fields only
		if ($b) {
			$msg=JText::_("SCPAW_CONFIG_SAVED");
		}
		else
		{
			$dbmsg=$this->_db->getErrorMsg();
			$msg=JText::_("SCPAW_CONFIG_NOT_SAVED") . $dbmsg;
		}
		$mainframe=JFactory::getApplication();
		$mainframe->enqueueMessage($msg);
		$mainframe->redirect("index.php?option=com_simplecaddy&action=scplugins&task=showpluginconfig&pluginname=scpayanyway");
	}

	function cancel() {
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=scplugins&task=showpluginconfig&pluginname=scpayanyway");
	}

	function main() {
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=scplugins&task=show");
	}
}

//The Content plugin Loadmodule
class plgContentScpayanyway extends JPlugin
{
	var $debugshow="hidden"; // just for testing purposes
	var $_plugin_number	= 0;

	function __construct( &$subject, $config )
	{
        parent::__construct( $subject, $config );
        $this->loadLanguage(); // necessary or not, let's make sure we get the language file
	}

	public function _setPluginNumber()
	{
		$this->_plugin_number = (int)$this->_plugin_number + 1; // only the first occurrence of the plugin should load css
	}

	function onContentPrepare($context, &$article, &$params, $page = 0 )
	{
		if (!JComponentHelper::isEnabled('com_simplecaddy', true)) { // check for the component install
			echo "<div style='color:red;'>The SimpleCaddy component is not installed or is not enabled</div>";
			return "";
		}

        $regex = '/{(scpayanyway)\s*(.*?)}/i'; // the plugin code to get from content

        $parms=array();
        $matches = array();
        preg_match_all( $regex, $article->text, $matches, PREG_SET_ORDER );
        foreach ($matches as $elm) {
 			$this->_setPluginNumber();
 			if ($this->_plugin_number==1) { // get the stylesheet only ONCE per page
				JHTML::stylesheet('components/com_simplecaddy/css/simplecaddy.css' );
				// on windows servers this may need to be changed to
				// JHTML::stylesheet('components\com_simplecaddy\css\simplecaddy.css' );
 			}
 			if ($this->_plugin_number>1 ) { // there should be only ONE payment plugin per page...
	            $article->text = preg_replace($regex, JText::_("SC_EXTRA_PLUGINS_REMOVED"), $article->text, 1);
		 		return true;
 			}
			$line=str_replace("&nbsp;", " ", $elm[2]);
            $line=str_replace(" ", "&", $line);
            $line=strtolower($line);
            parse_str( $line, $parms );

            if (!isset($parms['type'])) { // no type provided, or just forgot...
            	$parms["type"]="checkout";
            }

        	// get all different types of display here, define manually to avoid hacking of the code
        	switch (strtolower($parms['type']) )
			{
				case "payurl":
					$this->showPayAnyWayPayURL($params);
					break;
       			case "checkout": // the default if nothing has been provided
                	$html=$this->showPayAnyWayScreen($parms);
                	break;
        		default: // anything else provides an error message
                	$html=JText::_("SC_THIS_PLUGIN_TYPE_NOT_SUPPORTED"). "({$parms['type']})";
        	}
            $article->text = preg_replace($regex, $html, $article->text, 1);
        }
        return true;
	}

	function showPayAnyWayScreen($parms)
	{
		$mainframe=JFactory::getApplication();
		$input=$mainframe->input;
		$cfg=new scpayanywayconfiguration();

		$mnt_id = $cfg->mnt_id;
		$mnt_data_integrity_code = $cfg->mnt_data_integrity_code;
		$mnt_test_mode = $cfg->mnt_test_mode;
		$mnt_server = $cfg->mnt_server;
		$mnt_currency_code = 'RUB';

		$ordercode=$input->get("data"); // the data contains the ordercode when you finish the details page

		$orders=new orders();
		$orderid=$orders->getOrderIdFromCart($ordercode);
		$order=new order();
		$order->load($orderid);

		// add the details to the order
		$gtotal=0; //define the grand total

		$mnt_transaction_id = $orderid;
        $html = "<form action='https://{$mnt_server}/assistant.htm' method='post' name='pawform'>";
		$html .="<input type='hidden' name='MNT_ID' value='{$mnt_id}'>";
		$html .="<input type='hidden' name='MNT_TRANSACTION_ID' value='{$mnt_transaction_id}'>";
		$html .="<input type='hidden' name='MNT_TEST_MODE' value='{$mnt_test_mode}'>";
		$html .="<input type='hidden' name='MNT_DESCRIPTION' value='{$order->email} {$order->telephone}'>";
		$html .="<input type='hidden' name='MNT_CURRENCY_CODE' value='{$mnt_currency_code}'>";

        $odetails=new orderdetail();
        $lst=$odetails->getDetailsByOrderId($orderid);

		foreach ($lst as $product)
            $gtotal += $product->total;

		if ($order->shipCost > 0)
		{
			// add shipping
			$gtotal += $order->shipCost;
		}
		if ($order->tax > 0)
		{
			// add taxes
			$gtotal += $order->tax;
		}
		$mnt_amount = number_format($gtotal, 2, '.', '');

		$html .="<input type='hidden' name='MNT_AMOUNT' value='{$mnt_amount}'>";
		$mnt_signature = md5($mnt_id.$mnt_transaction_id.$mnt_amount.$mnt_currency_code.$mnt_test_mode.$mnt_data_integrity_code);
		$html .="<input type='hidden' name='MNT_SIGNATURE' value='{$mnt_signature}'>";

		$html .= '<p>
        <input type="image" name="submit" src="../plugins/content/scpayanyway/images/paw-logo.png" align="left" style="margin-right:7px;"> <span style="font-size:11px; font-family: Arial, Verdana;">'.JText::_("SCPAW_PAYANYWAYINFO").'</span>
        <p>
        <input type="submit" name="submit" value="'.JText::_("SCPAW_PAYBUTTON").'"/>';
		$html .= "</form>";
		return $html;
	}

	const paw_kassa_VAT0     = '1104';  // НДС 0%
	const paw_kassa_VAT10    = '1103';  // НДС 10%
	const paw_kassa_VAT18    = '1102';  // НДС 18%
	const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
	const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
	const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%

	private static function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
												 $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
	{
		if ($success === true)
			$resultCode = '200';
		elseif ($repeatRequest === true)
			$resultCode = '402';
		else
			$resultCode = '500';
		$mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
		$response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$response .= "<MNT_RESPONSE>\n";
		$response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
		$response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
		$response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
		$response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
		if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
		{
			$response .= "<MNT_ATTRIBUTES>\n";
			foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
				if (!empty($v))
					$response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
			$response .= "</MNT_ATTRIBUTES>\n";
		}
		$response .= "</MNT_RESPONSE>\n";
		if ($echo === true)
		{
			header("Content-type: application/xml");
			echo $response;
		}
		else
			return $response;
		if ($die === true)
			die;
		return '';
	}


	function showPayAnyWayPayURL($parms) {
		$mainframe=JFactory::getApplication();
		$input=$mainframe->input;
		$scfg=new sc_configuration();
		$cfg = new scpayanywayconfiguration();

		$mnt_data_integrity_code = $cfg->mnt_data_integrity_code;
		$mnt_id = $input->get("MNT_ID");
		$mnt_amount = $input->get("MNT_AMOUNT");
		$mnt_signature = $input->get("MNT_SIGNATURE");
		$mnt_currency_code = $input->get("MNT_CURRENCY_CODE");
		$mnt_subscriber_id = $input->get("MNT_SUBSCRIBER_ID");
		$mnt_test_mode = $input->get("MNT_TEST_MODE");
		$mnt_kassa = $cfg->mnt_kassa;
        $mnt_transaction_id = $input->get("MNT_TRANSACTION_ID"); // orderid coming back from PayAnyWay
        $mnt_operation_id = $input->get("MNT_OPERATION_ID"); // Moneta.ru Operation ID
		$signature = md5($mnt_id.$mnt_transaction_id.$mnt_operation_id.$mnt_amount.$mnt_currency_code.$mnt_subscriber_id.$mnt_test_mode.$mnt_data_integrity_code);
		if ($signature == $mnt_signature)
		{
			$statuses = explode("\r\n", $scfg->get("ostatus"));
			$status = $statuses[count($statuses) - 1]; // set the status to the last one in the list

			$scorder = new order();
			$scorder->load($mnt_transaction_id);

			$scorder->paymentcode = "PayAnyWay: " . $mnt_operation_id;
			$scorder->status = $status;
			// obviously there are other changes you could make to an order upon successful payment...
			$scorder->store();

			if ($mnt_kassa == '1')
			{
				$odetails = new orderdetail();
				$lst = $odetails->getDetailsByOrderId($mnt_transaction_id);

				$gtotal = 0;
				//

				$taxRate = intval(round($scorder->tax / $scorder->total * 100));
				$vatTag = self::paw_kassa_VATNOVAT;
				if ($taxRate == 10)
					$vatTag = self::paw_kassa_VATWR10;
				if ($taxRate == 18)
					$vatTag = self::paw_kassa_VATWR18;

				$inventoryPositions = [];
				foreach ($lst as $product)
				{
					if ($product->total > 0)
					{
						$inventoryPositions[] = [
							'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($product->shorttext . " (" . $product->prodcode . ") " . $product->option))),
							'price' => $product->unitprice,
							'quantity' => $product->qty,
							'vatTag' => $vatTag,
							'taxRate' => $taxRate
						];
					}
					$gtotal += $product->total;
				}
				$kassa_delivery = null;
				if ($scorder->shipCost > 0)
				{ // add shipping
					$gtotal += $scorder->shipCost;
					$kassa_delivery = $scorder->shipCost;
				}
				if ($scorder->tax > 0)
				{ // add taxes
					$gtotal += $scorder->tax;
				}
				$kassa_inventory = json_encode($inventoryPositions);
				self::monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, true, false, true, true, $kassa_inventory, $scorder->email, $kassa_delivery);
			} else
			{
				echo "SUCCESS";
			}
		}
		else
		{
			echo "FAIL";
		}
		die();
	}
}